`` Popularity Checker 
`` How many Del.icio.us bookmarks for a website? 
`` (c) 2008 Scriptol.com
`` Free under the GNU GPL 2 License.
`` Requires the PHP interpreter.
`` Sources are compiled with the Scriptol PHP compiler 7.0
`` www.scriptol.com 
``
`` The program checks for the number of bookmarks
`` to each page of a website from the "http://del.icio.us site".
``
`` This program is free software; you can redistribute it and/or modify
`` it under the terms of the GNU General Public License as published by
`` the Free Software Foundation; either version 2 of the License, or
`` (at your option) any later version.

`` This program is distributed in the hope that it will be useful,
`` but WITHOUT ANY WARRANTY; without even the implied warranty of
`` MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
`` GNU General Public License for more details.

`` You should have received a copy of the GNU General Public License
`` along with this program; if not, write to the Free Software
`` Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
``

include "path.sol"
include "dom.sol"
include "url.sol"

boolean QUIET = false       // True to display nothing
boolean RECURSE = false     // True to scan the whole site
boolean PROCESSDEFAULT = true  // Check for duplicate URLs due to trailing slash
int LEVEL = 0              // recursivity level: 0 only the page, 1 only the links in the page, default unlilmited   

int counter       // Number of files checked
int okcount       // Number of good links

array params = {}
array checked = {}  // List of checked links
array marked = {}   // List of marked links
array broken = {}



// How to use this program

void usage()
	print
	print "Popularity Checher 1.2 - (c) 2008 Scriptol.com - Freeware."
	print "----------------------------------------------------------"
	print "Syntax:"
	print "  solp popche [options] url"
	print "Options:"
	print "  -r follow links (default the page only)."
	print "  -v verbose, display more infos."
	print "  -q quiet, display nothing."
	print "Arguments:"
	print "  url: http address of a page, usually the home page."
	print "Results stored into bookmarks.log."
	print "More info at: http://www.scriptol.com/scripts/"
	exit(0)
return


// Extract website and webpage's filename

text, text splitSite(text url)
    int pos = url.find('/', 8)
    if pos = nil  // no file
        text ext = Path.getExtension(url)
        if ext not in extensions return url, ""  // site only 
        die("$url not a valid url")
    /if    
    text site = url[0 -- pos]
    text filename = url[pos + 1 ..]
return site, filename    

// Internal link with protocol and website?

boolean isInternal(text url)
    int l = website.length()
    url = url.lower()
    
   //print url, website, url[.. l]
    if website = url[0 -- l] return true
return false    


void makeLogs(boolean flag)
    global okcount
    global counter
    
    file f = fopen("bookmarks.log", "w")	
    
    f.write("[Bookmarked]\n")
    if marked.size() = 0
        f.write("None\n")
    else
	   for text k, text v in marked
	       text line = v  + " " + k
	       f.write(line)
	       f.write("\n")
	   /for
       text p = plural(okcount)
       f.write("$okcount bookmark$p, for $counter pages checked.\n")
       if flag let f.write("Not completed, access denied.") 
	/if  
	
    f.write("\n")
    f.write("[Broken]\n")
    if broken.size() = 0
        f.write("None\n")
    else
        for text b in broken
            f.write(b)
            f.write("\n")
        /for
    /if    
	f.close()
return

// Processing bookmarks

int ping(text url)

    text bookPage = @file_get_contents ("http://del.icio.us/url/check?url=$url&submit=check%20url&settagview=list")
    if trim(bookPage) = ""
       print "Access denied at $url"
       return -1
    /if

    array result
    text exp
    ~~
    $exp = '/<span class="savers\d+">(\d+)<\/span>/';
    ~~
    int x = preg_match(exp, bookPage, result)
    if x = 0 return 0
    
return intval(result[1])    


// Perform a check on the site of bookmarks

int checkMarks(text url)
    counter + 1
    checked.push(url)
    //if true return 0  
    if DEBUG print "Checking $url"
    int result = ping(url)
    if result > 0
        okcount + result
        print result , "in", url
        marked[url] = result
    /if
    if result < 0
        text e = "Access to results denied."
        broken.push(e) 
        makeLogs(true)  
        die(e)
    /if  
return result


//  Extract links and return an array of the list

array pageScan(text fname, text caller)

  DOMNode current = null
  DOMElement elem = null
  boolean xres
  
  array links = {}
 
  DOMDocument d = DOMDocument()
  
  ~~
    $xres = @$d->loadHTMLFile($fname);
  ~~  

  if xres = false
     print "Error $fname not found in $caller"
     broken.push(fname)
     return array()
  /if  

  DOMNodeList dnl = d.getElementsByTagName("a")
  if dnl.length = 0 return {}
  for int i in 0 .. dnl.length
    current = dnl.item(i)
    if current = null continue
    elem = current
    if elem.hasAttribute("href")
      links.push(elem.getAttribute("href"))
    /if
  /for
  
return links


// Checking the page

void httpCheck(text page, text caller)

	array links
	text reldir, src, ext

    if page[0] = "." return
    
    if DEBUG print "Entering $page "

    if substr(page, -1, 1) <> "/"
        
        text infos = pathinfo(page)
        reldir = @strtolower(infos['dirname'])
        src = @strtolower(infos['filename'])
        ext = @strtolower(infos['extension'])

        if ext <> nil
            ext = "." + ext 
            if ext not in extensions return
            src + ext
        /if    
    
        int status = sockAccess(page)
        if status 
        = 301
            if VERBOSE print "Skip $page redirected."
            broken.push(page) 
            return
        = 404
            print "Broken link $page"
            return    
        = 200
        else
            print "Unknow status code $status"
            return    
        /if
    else
        text oldir = page
        page = findDefault(page)
        if VERBOSE
            if oldir <> page
                print "Default page $page"
            /if
        /if 
        checked.push(oldir)           
    /if

    if VERBOSE print "Processing  $reldir/$src"
    
    if page not in checked
        checkMarks(page)
    /if       
    
    if not RECURSE return
    if LEVEL < 1 return
    LEVEL - 1   

    links = pageScan(page, caller) 
    //print_r(links)
    if links.size() = 0 return         // get list of links into links  
    
    int l = links.size()
    for int i in 0 -- l
        text link = links[i]
        //print "LIST ($reldir) ($link) ", hasProtocol(link)
        if link[0] = "#"  continue
        int p = strpos(link, "#", 0)
        if p <> 0
          link = link[0 -- p]
        /if
        if hasProtocol(link)            
            if not isInternal(link) continue
        else
            if link.length() > 7
                if link[ .. 6] = "mailto:"
                    if DEBUG print "Skipped mailto." 
                    continue
                /if     
            /if
            link = Path.merge(reldir, link)
        /if 
        if PROCESSDEFAULT
            if link[ -1 ..] = "/" 
                text home = findDefault(link)
                if home not in checked let checked.push(home)
            /if
        /if    
    
        if link in checked continue
        httpCheck(link, page)
   /for   

return


// Parsing command line parameters
// Stored into an array to overcome problems with PHP's global variables

void processCommand(int argnum, array arguments)

	text opt

	if argnum <  2
		usage()
	/if	

	for text param in arguments
		if param.length() > 1
			opt = param[..1]
		else
			usage()
		/if
        
		if opt 
        = "-v" 
			VERBOSE = true
			continue
		= "-q" 
			QUIET = true
			continue
		= "-u" 
			DEBUG = true
			continue
		= "-r"
            RECURSE = true
            LEVEL = 1
            /*
            if param.length() > 2
                text x = param[2 ..]
                LEVEL = int(x)
            /if
            */    
            continue
		/if
    
		if param[ .. 4] = "http:"
			server = param
			continue
		/if	

		if param[0] = "-" 
           print "Unknown command $param"  
           usage()
        /if   
		
		if server = nil
			server = param
			continue
		/if	
		
		print "Unknown command $param"
    
        usage()
		
	/for

    if server = nil 
       die("You must provide a URL.")
    /if
  
	params["server"] = server

return



int main(int argc, array argv)

    text filename

	array x = argv[ 1 .. ]
	
	processCommand(argc, x)

    server = params["server"]
    //print server
  
    if not hasProtocol(server)
        server = "http://" + server
    /if  

    website, filename = splitSite(server)
    website = website.lower()
    
    domain = website[7 ..]    
    if substr(domain, -1, 1) = "/"
      domain = domain[ .. -1]
    /if

    //print server, " ", website, " ", filename    
  
    if not QUIET
        if VERBOSE = true print "Verbose mode enabled"
        if DEBUG = true print "Debug mode enabled"
        print "Website is", website
        print "Domain is", domain
        if LEVEL print "Internal links in the page checked too"
        print "Starting from $server"
    /if

    httpCheck(server, server)
	
	if QUIET return 0
	
	print okcount, "Bookmark" + plural(okcount), "out of", counter, "pages checked."
	
	// Building logs
	// Copy bookmarks.log under another name to save it
    makeLogs(false)	
	
return 0

main($argc, $argv)
