<?php
$DEBUG=false;
$VERBOSE=false;
$website="";
$server="";
$domain="";
$extensions=array(".php",".html",".htm",".php3",".php4",".php5",".asp",".shtml",".dhtml",".jsp",".xhtml");
function sockAccess($page)
{
   $errno="";
   $errstr="";
   $fname="";
   $fp=0;
   global $domain;
   $fp=fsockopen($domain,80,$errno,$errstr,30);

   if($fp===0)
   {
      die("Error $errstr ($errno)");
   }
   $out="GET /$fname HTTP/1.1\r\n";
   $out.="Host: $domain\r\n";
   $out.="Connection: Close\r\n\r\n";

   fwrite($fp,$out);
   $content=fgets($fp);
   $code=trim(substr($content,9,4));
   fclose($fp);
   return intval($code);
}

function url_exists($url)
{
   $status=sockAccess($url);
   global $DEBUG;
   if($DEBUG)
   {
      echo "exists $url $status", "\n";
   }
   if($status===404)
   {
      return false;
   }
   return true;
}

function findDefault($thedir)
{
   global $website;
   $l=strlen($website);
   $url=substr($thedir,$l);
   global $VERBOSE;
   if($VERBOSE)
   {
      echo "Get default for:", " ", $url, "\n";
   }
   global $extensions;
   reset($extensions);
   do
   {
      $ext= current($extensions);
      $url=$thedir."index".$ext;
      if(url_exists($url))
      {
         return $url;
      }
   }
   while(!(next($extensions) === false));

   global $extensions;
   reset($extensions);
   do
   {
      $ext= current($extensions);
      $url=$thedir."default".$ext;
      if(url_exists($url))
      {
         return $url;
      }
   }
   while(!(next($extensions) === false));

   global $extensions;
   reset($extensions);
   do
   {
      $ext= current($extensions);
      $url=$thedir."home".$ext;
      if(url_exists($url))
      {
         return $url;
      }
   }
   while(!(next($extensions) === false));

   global $extensions;
   reset($extensions);
   do
   {
      $ext= current($extensions);
      $url=$thedir."accueil".$ext;
      if(url_exists($url))
      {
         return $url;
      }
   }
   while(!(next($extensions) === false));

   $url=$thedir."index";
   if(url_exists($url))
   {
      return $url;
   }
   $url=$thedir."home";
   if(url_exists($url))
   {
      return $url;
   }
   $url=$thedir."accueil";
   if(url_exists($url))
   {
      return $url;
   }
   $url=$thedir."default";
   if(url_exists($url))
   {
      return $url;
   }
   return $thedir;
}

// convert local to URL and to unix
function setURL($name)
{
   for($i=0;$i<strlen($name);$i++)
   {
      if($name{$i}==="\\")
      {
         $name{$i}="/";
      }
   }
   return $name;
}

function textToUTF8($content)
{
   $content=str_replace("&","&amp;",$content);
   $content=str_replace("<","&lt;",$content);
   $content=str_replace(">","&gt;",$content);
   return $content;
}

// remove trailing slash or backslash
function noSlash($pth)
{
   $c=substr($pth,-1);
   if(($c==="/")||($c==="\\"))
   {
      return substr($pth,0,-1);
   }
   return $pth;
}

function siteOffset($theurl)
{
   $offset=0;
   $offset=strpos($theurl,"http://");
   if($offset===false)
   {
      $offset=strpos($theurl,"ftp://");
      if($offset===false)
      {
         $offset=strpos($theurl,"https://");
         if($offset!=false)
         {
            $offset+=8;
         }
      }
      else
      {
         $offset+=6;
      }
   }
   else
   {
      $offset+=7;
   }
   return $offset;
}

// test if this is a remote  address (host included in the string)
function hasProtocol($theurl)
{
   $lowname=strtolower(ltrim($theurl));
   if(substr($lowname,0,7)==="http://")
   {
      return true;
   }
   if(substr($lowname,0,6)==="ftp://")
   {
      return true;
   }
   if(substr($lowname,0,8)==="https://")
   {
      return true;
   }
   return false;
}

// return remote part and local part
function splitURL($theurl)
{
   $offset=siteOffset($theurl);
   if($offset===false)
   {
      return array("",$theurl);
   }
   $offset=strpos($theurl,"/",$offset);
   if($offset===false)
   {
      return array($theurl,"");
   }
   return array(substr($theurl,0,$offset),substr($theurl,$offset+1));
}

// get the remote part of URL
function getURL($theurl)
{
   $offset=siteOffset($theurl);
   $offset=strpos($theurl,"/",$offset);
   if($offset===false)
   {
      return $theurl;
   }
   return substr($theurl,0,$offset);
}

function setWindows($name)
{
   for($i=0;$i<strlen($name);$i++)
   {
      if($name{$i}==="/")
      {
         $name{$i}="\\";
      }
   }
   return $name;
}

// if drive letter in path, change drive
function changeDir($pth)
{
   chdir($pth);
   global $DEBUG;
   global $VERBOSE;
   if($DEBUG&&$VERBOSE)
   {
      echo "Now path is", " ", getcwd(), "\n";
   }
   return;
}

// Check if the source ends with the string search
function endWith($source,$search)
{
   $last=substr($search,-1);
   if(($last==="/")||($last==="\\"))
   {
      $search=substr($search,0,-1);
   }
   $lsea=strlen($search);
   $lsrc=strlen($source);
   if($lsrc<$lsea)
   {
      return false;
   }
   if(substr($source,-$lsea)===$search)
   {
      return true;
   }
   return false;
}


?>
